package sun.misc;

import java.security.AccessControlContext;
import sun.nio.ch.Interruptible;
import java.lang.reflect.Executable;
import java.lang.annotation.Annotation;
import java.util.Map;
import sun.reflect.annotation.AnnotationType;
import sun.reflect.ConstantPool;

public interface JavaLangAccess
{
    public abstract ConstantPool getConstantPool(Class<?> p0);
    
    public abstract boolean casAnnotationType(Class<?> p0, AnnotationType p1, AnnotationType p2);
    
    public abstract AnnotationType getAnnotationType(Class<?> p0);
    
    public abstract Map<Class<? extends Annotation>, Annotation> getDeclaredAnnotationMap(Class<?> p0);
    
    public abstract byte[] getRawClassAnnotations(Class<?> p0);
    
    public abstract byte[] getRawClassTypeAnnotations(Class<?> p0);
    
    public abstract byte[] getRawExecutableTypeAnnotations(Executable p0);
    
    public abstract <E extends Enum<E>> E[] getEnumConstantsShared(Class<E> p0);
    
    public abstract void blockedOn(Thread p0, Interruptible p1);
    
    public abstract void registerShutdownHook(int p0, boolean p1, Runnable p2);
    
    public abstract int getStackTraceDepth(Throwable p0);
    
    public abstract StackTraceElement getStackTraceElement(Throwable p0, int p1);
    
    public abstract String newStringUnsafe(char[] p0);
    
    public abstract Thread newThreadWithAcc(Runnable p0, AccessControlContext p1);
    
    public abstract void invokeFinalize(Object p0) throws Throwable;
}
